/*
 * Copyright 2010-2014 Ning, Inc.
 * Copyright 2014-2020 Groupon, Inc
 * Copyright 2020-2021 Equinix, Inc
 * Copyright 2014-2021 The Billing Project, LLC
 *
 * The Billing Project licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */


package org.killbill.billing.client.model.gen;

import java.util.Objects;
import java.util.Arrays;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import org.killbill.billing.client.model.gen.UsagePrice;

/**
 *           DO NOT EDIT !!!
 *
 * This code has been generated by the Kill Bill swagger generator.
 *  @See https://github.com/killbill/killbill-swagger-coden
 */
import org.killbill.billing.client.model.KillBillObject;

public class PhasePrice {

    private String planName = null;

    private String phaseName = null;

    private String phaseType = null;

    private BigDecimal fixedPrice = null;

    private BigDecimal recurringPrice = null;

    private List<UsagePrice> usagePrices = null;


    public PhasePrice() {
    }

    public PhasePrice(final String planName,
                     final String phaseName,
                     final String phaseType,
                     final BigDecimal fixedPrice,
                     final BigDecimal recurringPrice,
                     final List<UsagePrice> usagePrices) {
        this.planName = planName;
        this.phaseName = phaseName;
        this.phaseType = phaseType;
        this.fixedPrice = fixedPrice;
        this.recurringPrice = recurringPrice;
        this.usagePrices = usagePrices;

    }


    public PhasePrice setPlanName(final String planName) {
        this.planName = planName;
        return this;
    }

    public String getPlanName() {
        return planName;
    }

    public PhasePrice setPhaseName(final String phaseName) {
        this.phaseName = phaseName;
        return this;
    }

    public String getPhaseName() {
        return phaseName;
    }

    public PhasePrice setPhaseType(final String phaseType) {
        this.phaseType = phaseType;
        return this;
    }

    public String getPhaseType() {
        return phaseType;
    }

    public PhasePrice setFixedPrice(final BigDecimal fixedPrice) {
        this.fixedPrice = fixedPrice;
        return this;
    }

    public BigDecimal getFixedPrice() {
        return fixedPrice;
    }

    public PhasePrice setRecurringPrice(final BigDecimal recurringPrice) {
        this.recurringPrice = recurringPrice;
        return this;
    }

    public BigDecimal getRecurringPrice() {
        return recurringPrice;
    }

    public PhasePrice setUsagePrices(final List<UsagePrice> usagePrices) {
        this.usagePrices = usagePrices;
        return this;
    }

    public PhasePrice addUsagePricesItem(final UsagePrice usagePricesItem) {
        if (this.usagePrices == null) {
            this.usagePrices = new ArrayList<UsagePrice>();
        }
        this.usagePrices.add(usagePricesItem);
        return this;
    }

    public List<UsagePrice> getUsagePrices() {
        return usagePrices;
    }

    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        PhasePrice phasePrice = (PhasePrice) o;
        return Objects.equals(this.planName, phasePrice.planName) &&
            Objects.equals(this.phaseName, phasePrice.phaseName) &&
            Objects.equals(this.phaseType, phasePrice.phaseType) &&
            Objects.equals(this.fixedPrice, phasePrice.fixedPrice) &&
            Objects.equals(this.recurringPrice, phasePrice.recurringPrice) &&
            Objects.equals(this.usagePrices, phasePrice.usagePrices);
    }

    @Override
    public int hashCode() {
        return Objects.hash(planName,
            phaseName,
            phaseType,
            fixedPrice,
            recurringPrice,
            usagePrices);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class PhasePrice {\n");
        
        sb.append("    planName: ").append(toIndentedString(planName)).append("\n");
        sb.append("    phaseName: ").append(toIndentedString(phaseName)).append("\n");
        sb.append("    phaseType: ").append(toIndentedString(phaseType)).append("\n");
        sb.append("    fixedPrice: ").append(toIndentedString(fixedPrice)).append("\n");
        sb.append("    recurringPrice: ").append(toIndentedString(recurringPrice)).append("\n");
        sb.append("    usagePrices: ").append(toIndentedString(usagePrices)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}

