/*
 * Copyright 2010-2014 Ning, Inc.
 * Copyright 2014-2020 Groupon, Inc
 * Copyright 2020-2021 Equinix, Inc
 * Copyright 2014-2021 The Billing Project, LLC
 *
 * The Billing Project licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */


package org.killbill.billing.client.model.gen;

import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import org.killbill.billing.catalog.api.BillingPeriod;
import org.killbill.billing.client.model.gen.Price;

/**
 *           DO NOT EDIT !!!
 *
 * This code has been generated by the Kill Bill swagger generator.
 *  @See https://github.com/killbill/killbill-swagger-coden
 */
import org.killbill.billing.client.model.KillBillObject;

public class PlanDetail {

    private String product = null;

    private String plan = null;

    private String priceList = null;

    private BillingPeriod finalPhaseBillingPeriod = null;

    private List<Price> finalPhaseRecurringPrice = null;


    public PlanDetail() {
    }

    public PlanDetail(final String product,
                     final String plan,
                     final String priceList,
                     final BillingPeriod finalPhaseBillingPeriod,
                     final List<Price> finalPhaseRecurringPrice) {
        this.product = product;
        this.plan = plan;
        this.priceList = priceList;
        this.finalPhaseBillingPeriod = finalPhaseBillingPeriod;
        this.finalPhaseRecurringPrice = finalPhaseRecurringPrice;

    }


    public PlanDetail setProduct(final String product) {
        this.product = product;
        return this;
    }

    public String getProduct() {
        return product;
    }

    public PlanDetail setPlan(final String plan) {
        this.plan = plan;
        return this;
    }

    public String getPlan() {
        return plan;
    }

    public PlanDetail setPriceList(final String priceList) {
        this.priceList = priceList;
        return this;
    }

    public String getPriceList() {
        return priceList;
    }

    public PlanDetail setFinalPhaseBillingPeriod(final BillingPeriod finalPhaseBillingPeriod) {
        this.finalPhaseBillingPeriod = finalPhaseBillingPeriod;
        return this;
    }

    public BillingPeriod getFinalPhaseBillingPeriod() {
        return finalPhaseBillingPeriod;
    }

    public PlanDetail setFinalPhaseRecurringPrice(final List<Price> finalPhaseRecurringPrice) {
        this.finalPhaseRecurringPrice = finalPhaseRecurringPrice;
        return this;
    }

    public PlanDetail addFinalPhaseRecurringPriceItem(final Price finalPhaseRecurringPriceItem) {
        if (this.finalPhaseRecurringPrice == null) {
            this.finalPhaseRecurringPrice = new ArrayList<Price>();
        }
        this.finalPhaseRecurringPrice.add(finalPhaseRecurringPriceItem);
        return this;
    }

    public List<Price> getFinalPhaseRecurringPrice() {
        return finalPhaseRecurringPrice;
    }

    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        PlanDetail planDetail = (PlanDetail) o;
        return Objects.equals(this.product, planDetail.product) &&
            Objects.equals(this.plan, planDetail.plan) &&
            Objects.equals(this.priceList, planDetail.priceList) &&
            Objects.equals(this.finalPhaseBillingPeriod, planDetail.finalPhaseBillingPeriod) &&
            Objects.equals(this.finalPhaseRecurringPrice, planDetail.finalPhaseRecurringPrice);
    }

    @Override
    public int hashCode() {
        return Objects.hash(product,
            plan,
            priceList,
            finalPhaseBillingPeriod,
            finalPhaseRecurringPrice);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class PlanDetail {\n");
        
        sb.append("    product: ").append(toIndentedString(product)).append("\n");
        sb.append("    plan: ").append(toIndentedString(plan)).append("\n");
        sb.append("    priceList: ").append(toIndentedString(priceList)).append("\n");
        sb.append("    finalPhaseBillingPeriod: ").append(toIndentedString(finalPhaseBillingPeriod)).append("\n");
        sb.append("    finalPhaseRecurringPrice: ").append(toIndentedString(finalPhaseRecurringPrice)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}

