/*
 * Copyright 2010-2014 Ning, Inc.
 * Copyright 2014-2020 Groupon, Inc
 * Copyright 2020-2021 Equinix, Inc
 * Copyright 2014-2021 The Billing Project, LLC
 *
 * The Billing Project licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */


package org.killbill.billing.client.model.gen;

import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;

/**
 *           DO NOT EDIT !!!
 *
 * This code has been generated by the Kill Bill swagger generator.
 *  @See https://github.com/killbill/killbill-swagger-coden
 */
import org.killbill.billing.client.model.KillBillObject;

public class UserRoles {

    private String username = null;

    private String password = null;

    private List<String> roles = new ArrayList<String>();


    public UserRoles() {
    }

    public UserRoles(final String username,
                     final String password,
                     final List<String> roles) {
        this.username = username;
        this.password = password;
        this.roles = roles;

    }


    public UserRoles setUsername(final String username) {
        this.username = username;
        return this;
    }

    public String getUsername() {
        return username;
    }

    public UserRoles setPassword(final String password) {
        this.password = password;
        return this;
    }

    public String getPassword() {
        return password;
    }

    public UserRoles setRoles(final List<String> roles) {
        this.roles = roles;
        return this;
    }

    public UserRoles addRolesItem(final String rolesItem) {
        this.roles.add(rolesItem);
        return this;
    }

    public List<String> getRoles() {
        return roles;
    }

    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        UserRoles userRoles = (UserRoles) o;
        return Objects.equals(this.username, userRoles.username) &&
            Objects.equals(this.password, userRoles.password) &&
            Objects.equals(this.roles, userRoles.roles);
    }

    @Override
    public int hashCode() {
        return Objects.hash(username,
            password,
            roles);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class UserRoles {\n");
        
        sb.append("    username: ").append(toIndentedString(username)).append("\n");
        sb.append("    password: ").append(toIndentedString(password)).append("\n");
        sb.append("    roles: ").append(toIndentedString(roles)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}

